/* Trackuino copyright (C) 2010  EA5HAV Javi */
/* Modified by F4HUY 2018 */
#include <SoftwareSerial.h>

// Trackuino custom libs
#include "config.h"
#include "afsk_avr.h"
#include "aprs.h"
#include "gps.h"
#include "pin.h"
#include "power.h"
#include "sensors_avr.h"

#define DRA_RXD 5   //NOT USED
#define DRA_TXD 12  //TO SEND DATA TO TX DRA818V
SoftwareSerial dra_serial(DRA_RXD, DRA_TXD); //for DRA818

const int PDLINE = 3; // DRA INIT LINE
const int GPSpw =  2;  //GPS Enable PIN  //not used
static const uint32_t VALID_POS_TIMEOUT = 2000;  // ms
static int32_t next_aprs = 0;
//////////////////////////////////////////////////////////////////////////////////////////////

/*
pin assignement:
0 GPS
1 GPS
2 GPS POWER CTRL
3 DRA WAKEUP CTRL
4 LM60 TP IN/VCC
5 
6 TRAFFIC LED
7 BUZZER
8 
9 SPEED LED DEBUG
10 PTT
11 AUDIO/ICSP MOSI
12 SERIAL TX TO DRA/ICSP MISO
13 ICSP SCK

A0 LM60 TP IN/DATA
A1 
A2 VMETER_PIN
A3 
A4 
A5 
*/

void setup()
{
  pinMode(TRAFFIC, OUTPUT); //LED will blink every APRS send
  digitalWrite(TRAFFIC, LOW);
  
  //pinMode(LEDDEBUG, OUTPUT); //debug led attached to pin 9, speed value debug
  //digitalWrite(LEDDEBUG, LOW); 
  
  pinMode(GPSpw, OUTPUT);  //GPS power management
  digitalWrite(GPSpw, HIGH);
    
  dra_serial.begin(9600); //9600 bp serial DRA
  Serial.begin(GPS_BAUDRATE);
  dra_serial.println("AT+DMOSETGROUP=0,144.8000,144.8000,0000,4,0000"); //Send 144.800 QRG

  afsk_setup();
  gps_setup();
  sensors_setup();

  //little melodie at startup
 tone(7, 1000, 25); 
 delay(50);
 tone(7, 1200, 25);
 delay(50); 
 tone(7, 1500, 25); 
 delay(50);
 tone(7, 1700, 25); 
 delay(50);
 tone(7, 1900, 25); 
  
//////////////////////////////////////////////////////////////////////////////////////////////
  // Do not start until we get a valid time reference
  // for slotted transmissions.
  
  if (APRS_SLOT >= 0) 
  {
    do {
      while (! Serial.available());
        //power_save();
    } while (! gps_decode(Serial.read()));
    
    next_aprs = millis() + 1000 *
      (APRS_PERIOD_HIGH - (gps_seconds + APRS_PERIOD_HIGH - APRS_SLOT) % APRS_PERIOD_HIGH);
  }
  else {
    next_aprs = millis();
  }  
  // TODO: beep while we get a fix, maybe indicating the number of
  // visible satellites by a series of short beeps?
  
} 

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void get_pos()
{
  // Get a valid position from the GPS
  int valid_pos = 0;
  uint32_t timeout = millis();

  gps_reset_parser();

  do {
    if (Serial.available())
      valid_pos = gps_decode(Serial.read());
  } while ( (millis() - timeout < VALID_POS_TIMEOUT) && ! valid_pos) ;
  //BUZZER_ALTITUDE REMOVED
}
//////////////////////////////////////////////////////////////////////////////////////
void loop()
{
  // Time for another APRS frame
  if ((int32_t) (millis() - next_aprs) >= 0) {
    get_pos();
    if (gps_speed > 3) 
    {
      digitalWrite(TRAFFIC, HIGH); 
      aprs_send();
      digitalWrite(TRAFFIC, LOW);
      next_aprs += APRS_PERIOD_HIGH * 1000L;
      while (afsk_flush()) 
      {
      power_save();
    }
    } 
   else
    {
      digitalWrite(TRAFFIC, HIGH); 
      aprs_send();
      digitalWrite(TRAFFIC, LOW);
      next_aprs += APRS_PERIOD_LOW * 1000L;
      while (afsk_flush()) 
      {
      power_save();
    }
    }
//////////////////////////////////////////////////////////////////////////////////////////    
  } else {
    // Discard GPS data received during sleep window
    while (Serial.available()) {
      Serial.read();
    }
  }
  power_save(); // Incoming GPS data or interrupts will wake us up
}
//////////////////////////////////////////////////////////////////////////////////////
